################################################################################
# Feuerfuchs Addons Installer -- AddonsClass: Extension
#   file: Source\AddonsClass\Extension.nsh
#   desc: To manage the Extension list before the compile time.
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# TempFile
################################################################################
!tempfile "__EXTENSIONS_SECTION"
!tempfile "__EXTENSIONS_DESC"

!define __WRITE_EXTENSIONS_SEC '!appendfile "${__EXTENSIONS_SECTION}"'
!define __WRITE_EXTENSIONS_DESC '!appendfile "${__EXTENSIONS_DESC}"'



################################################################################
# Define
################################################################################
; Define a Counter
${DECLARE_COUNTER} "EXTENSION_COUNTER"



################################################################################
# Macros
################################################################################

# ---------------
# Add Extension
# ---------------
!macro AddExtension NAME PACKAGE DESC SELECTED
    ; ${EXTENSION_COUNTER}++
    ${COUNTER_FORWARD} "EXTENSION_COUNTER"

    ; Define
    !define SEC_ID_NAME "Section_Extension${EXTENSION_COUNTER}"

    ; Write `Section' to ${__EXTENSIONS_SECTION}, which will be included later.
    !if "${SELECTED}" == "true"
        ${__WRITE_EXTENSIONS_SEC} 'Section "${NAME}" "${SEC_ID_NAME}"$\n'
    !else
        ${__WRITE_EXTENSIONS_SEC} 'Section /o "${NAME}" "${SEC_ID_NAME}"$\n'
    !endif

    ${__WRITE_EXTENSIONS_SEC} '    ${char24}{Unless} ${char24}{FileExists} "$_TargetProfileDir_\extensions"$\n'
    ${__WRITE_EXTENSIONS_SEC} '        CreateDirectory "$_TargetProfileDir_\extensions"$\n'
    ${__WRITE_EXTENSIONS_SEC} '    ${char24}{EndUnless}$\n'
    ${__WRITE_EXTENSIONS_SEC} '    $\n'
    ${__WRITE_EXTENSIONS_SEC} '    SetOutPath "$_TargetProfileDir_\extensions"$\n'
    ${__WRITE_EXTENSIONS_SEC} '    File "AddonsPack\Extension\${PACKAGE}"$\n'
    ${__WRITE_EXTENSIONS_SEC} 'SectionEnd$\n'

    ; Write `Description'
    ${__WRITE_EXTENSIONS_DESC} '!insertmacro MUI_DESCRIPTION_TEXT "${char24}{${SEC_ID_NAME}}" "${DESC}"$\n'

    ; Set SectionIndexName-SectionIndexDigital Cross Tab
    ${__WRITE_EXTENSIONS_SEC} '${char24}{RECORD_SECTION_INDEX} "${SEC_ID_NAME}"$\n'

    ; Set Section Status
    ${RECORD_SECTION_STATE} "${SEC_ID_NAME}" "${SELECTED}"

    ; Undefine
    !undef SEC_ID_NAME
!macroend
!define AddExtension "!insertmacro AddExtension"




