################################################################################
# Feuerfuchs Addons Installer -- AddonsClass: Group
#   file: Source\AddonsClass\Group.nsh
#   desc: To provide Group-Up Function
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# TempFile
################################################################################
!tempfile "__SECTIONGROUPS_DESC"
!define __WRITE_SECTIONGROUPS_DESC '!appendfile "${__SECTIONGROUPS_DESC}"'



################################################################################
# Define
################################################################################
; Define a Counter
${DECLARE_COUNTER} "GROUP_COUNTER"



################################################################################
# Macros
################################################################################

# ---------------
# Group Extension Begin
# ---------------
!macro GroupExtensionBegin NAME DESC EXPAND
    ; ${GROUP_COUNTER}++
    ${COUNTER_FORWARD} "GROUP_COUNTER"

    ; Define
    !define SEC_ID_NAME "SectionGroup_Custom${GROUP_COUNTER}"

    ; Write `SectionGroup' to ${EXTENSIONS_SECTION}, which will be included later.
    !if "${EXPAND}" == "true"
    ${__WRITE_EXTENSIONS_SEC} 'SectionGroup /e "${NAME}" "${SEC_ID_NAME}"$\n'
    !else
    ${__WRITE_EXTENSIONS_SEC} 'SectionGroup "${NAME}" "${SEC_ID_NAME}"$\n'
    !endif

    ; Write `Description'
    ${__WRITE_SECTIONGROUPS_DESC} '!insertmacro MUI_DESCRIPTION_TEXT "${char24}{${SEC_ID_NAME}}" "${DESC}"$\n'

    ; Undefine
    !undef SEC_ID_NAME
!macroend
!define GroupExtensionBegin "!insertmacro GroupExtensionBegin"


# ---------------
# Group Extension End
# ---------------
!macro GroupExtensionEnd
    ; Write `SectionGroupEnd' to ${EXTENSIONS_SEC}, which will be included later.
    ${__WRITE_EXTENSIONS_SEC} 'SectionGroupEnd$\n'
!macroend
!define GroupExtensionEnd "!insertmacro GroupExtensionEnd"



# ---------------
# Group Theme Begin
# ---------------
!macro GroupThemeBegin NAME DESC EXPAND
    ; ${GROUP_COUNTER}++
    ${COUNTER_FORWARD} "GROUP_COUNTER"

    ; Define
    !define SEC_ID_NAME "SectionGroup_Custom${GROUP_COUNTER}"

    ; Write `SectionGroup' to ${THEMES_SECTION}, which will be included later.
    !if "${EXPAND}" == "true"
    ${__WRITE_THEMES_SEC} 'SectionGroup /e "${NAME}" "${SEC_ID_NAME}"$\n'
    !else
    ${__WRITE_THEMES_SEC} 'SectionGroup "${NAME}" "${SEC_ID_NAME}"$\n'
    !endif

    ; Write `Description'
    ${__WRITE_SECTIONGROUPS_DESC} '!insertmacro MUI_DESCRIPTION_TEXT "${char24}{${SEC_ID_NAME}}" "${DESC}"$\n'

    ; Undefine
    !undef SEC_ID_NAME
!macroend
!define GroupThemeBegin "!insertmacro GroupThemeBegin"


# ---------------
# Group Theme End
# ---------------
!macro GroupThemeEnd
    ; Write `SectionGroupEnd' to ${THEMES_SECTION}, which will be included later.
    ${__WRITE_THEMES_SEC} 'SectionGroupEnd$\n'
!macroend
!define GroupThemeEnd "!insertmacro GroupThemeEnd"




# ---------------
# Group SearchPlugin Begin
# ---------------
!macro GroupSearchPluginBegin NAME DESC EXPAND
    ; ${GROUP_COUNTER}++
    ${COUNTER_FORWARD} "GROUP_COUNTER"

    ; Define
    !define SEC_ID_NAME "SectionGroup_Custom${GROUP_COUNTER}"

    ; Write `SectionGroup' to ${SEARCHPLUGINS_SECTION}, which will be included later.
    !if "${EXPAND}" == "true"
    ${__WRITE_SEARCHPLUGINS_SEC} 'SectionGroup /e "${NAME}" "${SEC_ID_NAME}"$\n'
    !else
    ${__WRITE_SEARCHPLUGINS_SEC} 'SectionGroup "${NAME}" "${SEC_ID_NAME}"$\n'
    !endif

    ; Write `Description'
    ${__WRITE_SECTIONGROUPS_DESC} '!insertmacro MUI_DESCRIPTION_TEXT "${char24}{${SEC_ID_NAME}}" "${DESC}"$\n'

    ; Undefine
    !undef SEC_ID_NAME
!macroend
!define GroupSearchPluginBegin "!insertmacro GroupSearchPluginBegin"


# ---------------
# Group SearchPlugin End
# ---------------
!macro GroupSearchPluginEnd
    ; Write `SectionGroupEnd' to ${SEARCHPLUGINS_SECTION}, which will be included later.
    ${__WRITE_SEARCHPLUGINS_SEC} 'SectionGroupEnd$\n'
!macroend
!define GroupSearchPluginEnd "!insertmacro GroupSearchPluginEnd"


