################################################################################
# Feuerfuchs Addons Installer -- AddonsClass: SearchPlugin
#   file: Source\AddonsClass\SearchPlugin.nsh
#   desc: To manage the Search Plugin list before the compile time.
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# TempFile
################################################################################
!tempfile "__SEARCHPLUGINS_SECTION"
!tempfile "__SEARCHPLUGINS_DESC"

!define __WRITE_SEARCHPLUGINS_SEC '!appendfile "${__SEARCHPLUGINS_SECTION}"'
!define __WRITE_SEARCHPLUGINS_DESC '!appendfile "${__SEARCHPLUGINS_DESC}"'



################################################################################
# Define
################################################################################
; Define a Counter
${DECLARE_COUNTER} "SEARCHPLUGIN_COUNTER"



################################################################################
# Macros
################################################################################

# ---------------
# Add Extension
# ---------------
!macro AddSearchPlugin NAME PACKAGE DESC SELECTED
    ; ${EXTENSION_COUNTER}++
    ${COUNTER_FORWARD} "SEARCHPLUGIN_COUNTER"

    ; Define
    !define SEC_ID_NAME "Section_SearchPlugin${SEARCHPLUGIN_COUNTER}"

    ; Write `Section' to ${__SEARCHPLUGINS_SECTION}, which will be included later.
    !if "${SELECTED}" == "true"
        ${__WRITE_SEARCHPLUGINS_SEC} 'Section "${NAME}" "${SEC_ID_NAME}"$\n'
    !else
        ${__WRITE_SEARCHPLUGINS_SEC} 'Section /o "${NAME}" "${SEC_ID_NAME}"$\n'
    !endif

    ${__WRITE_SEARCHPLUGINS_SEC} '    ${char24}{Unless} ${char24}{FileExists} "$_TargetProfileDir_\searchplugins"$\n'
    ${__WRITE_SEARCHPLUGINS_SEC} '        CreateDirectory "$_TargetProfileDir_\searchplugins"$\n'
    ${__WRITE_SEARCHPLUGINS_SEC} '    ${char24}{EndUnless}$\n'
    ${__WRITE_SEARCHPLUGINS_SEC} '    $\n'
    ${__WRITE_SEARCHPLUGINS_SEC} '    SetOutPath "$_TargetProfileDir_\searchplugins"$\n'
    ${__WRITE_SEARCHPLUGINS_SEC} '    File "AddonsPack\SearchPlugin\${PACKAGE}"$\n'
    ${__WRITE_SEARCHPLUGINS_SEC} 'SectionEnd$\n'

    ; Write `Description'
    ${__WRITE_SEARCHPLUGINS_DESC} '!insertmacro MUI_DESCRIPTION_TEXT "${char24}{${SEC_ID_NAME}}" "${DESC}"$\n'

    ; Set SectionIndexName-SectionIndexDigital Cross Tab
    ${__WRITE_SEARCHPLUGINS_SEC} '${char24}{RECORD_SECTION_INDEX} "${SEC_ID_NAME}"$\n'

    ; Set Section Status
    ${RECORD_SECTION_STATE} "${SEC_ID_NAME}" "${SELECTED}"

    ; Undefine
    !undef SEC_ID_NAME
!macroend
!define AddSearchPlugin "!insertmacro AddSearchPlugin"

