################################################################################
# Feuerfuchs Addons Installer -- AddonsClass: Theme
#   file: Source\AddonsClass\Theme.nsh
#   desc: To manage the Theme list before the compile time.
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# TempFile
################################################################################
!tempfile "__THEMES_SECTION"
!tempfile "__THEMES_DESC"

!define __WRITE_THEMES_SEC '!appendfile "${__THEMES_SECTION}"'
!define __WRITE_THEMES_DESC '!appendfile "${__THEMES_DESC}"'



################################################################################
# Define
################################################################################
; Define a Counter
${DECLARE_COUNTER} "THEME_COUNTER"



################################################################################
# Macros
################################################################################

# ---------------
# Add Extension
# ---------------
!macro AddTheme NAME PACKAGE DESC SELECTED
    ; ${EXTENSION_COUNTER}++
    ${COUNTER_FORWARD} "THEME_COUNTER"

    ; Define
    !define SEC_ID_NAME "Section_Theme${THEME_COUNTER}"

    ; Write `Section' to ${__THEMES_SECTION}, which will be included later.
    !if "${SELECTED}" == "true"
        ${__WRITE_THEMES_SEC} 'Section "${NAME}" "${SEC_ID_NAME}"$\n'
    !else
        ${__WRITE_THEMES_SEC} 'Section /o "${NAME}" "${SEC_ID_NAME}"$\n'
    !endif

    ${__WRITE_THEMES_SEC} '    ${char24}{Unless} ${char24}{FileExists} "$_TargetProfileDir_\extensions"$\n'
    ${__WRITE_THEMES_SEC} '        CreateDirectory "$_TargetProfileDir_\extensions"$\n'
    ${__WRITE_THEMES_SEC} '    ${char24}{EndUnless}$\n'
    ${__WRITE_THEMES_SEC} '    $\n'
    ${__WRITE_THEMES_SEC} '    SetOutPath "$_TargetProfileDir_\extensions"$\n'
    ${__WRITE_THEMES_SEC} '    File "AddonsPack\Theme\${PACKAGE}"$\n'
    ${__WRITE_THEMES_SEC} 'SectionEnd$\n'

    ; Write `Description'
    ${__WRITE_THEMES_DESC} '!insertmacro MUI_DESCRIPTION_TEXT "${char24}{${SEC_ID_NAME}}" "${DESC}"$\n'

    ; Set SectionIndexName-SectionIndexDigital Cross Tab
    ${__WRITE_THEMES_SEC} '${char24}{RECORD_SECTION_INDEX} "${SEC_ID_NAME}"$\n'

    ; Set Section Status
    ${RECORD_SECTION_STATE} "${SEC_ID_NAME}" "${SELECTED}"

    ; Undefine
    !undef SEC_ID_NAME
!macroend
!define AddTheme "!insertmacro AddTheme"

