################################################################################
# Feuerfuchs Addons Installer -- LangTab: Translate Class
#   file: Source\LangTab\__TranslateClass.nsh
#   desc: Provide ${REF} and ${TRANSLATE} Command
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# Add Include Dir
################################################################################
!addincludedir "Source\LangTab" ; DO NOT delete this line



################################################################################
# Temp File
################################################################################
!tempfile "__LOCALE_LIST"
!tempfile "__MUI_LOCALE_LIST"

!define __WRITE_LOCALE_LIST '!appendfile "${__LOCALE_LIST}"'
!define __WRITE_MUI_LOCALE_LIST '!appendfile "${__MUI_LOCALE_LIST}"'


################################################################################
# Macro
################################################################################

# ---------------
# Locale Begin
# ---------------
!macro LOCALE_BEGIN LOCALE_NAME LOCALE_ID
    !define LANG "${LOCALE_NAME}"
    !define LANG_ID "${LOCALE_ID}"

    ${__WRITE_LOCALE_LIST} 'Push "${LOCALE_ID}"$\n'
    ${__WRITE_LOCALE_LIST} 'Push "${LOCALE_NAME}"$\n'

    !ifndef MUI_LOCALE_NAME
    ${__WRITE_MUI_LOCALE_LIST} '!insertmacro MUI_LANGUAGE "${LOCALE_NAME}"$\n'
    !else
    ${__WRITE_MUI_LOCALE_LIST} '!insertmacro MUI_LANGUAGE "${MUI_LOCALE_NAME}"$\n'
    !undef MUI_LOCALE_NAME
    !endif
!macroend
!define LOCALE_BEGIN "!insertmacro LOCALE_BEGIN"


# ---------------
# Locale End
# ---------------
!macro LOCALE_END
    !undef LANG
    !undef LANG_ID
!macroend
!define LOCALE_END "!insertmacro LOCALE_END"

# ---------------
# Reference
# ---------------
!macro REF STATEMENT
    ; Empty Macro
!macroend
!define REF "!insertmacro REF"


# ---------------
# Translate
# ---------------
!macro TRANSLATE LOCALE
    LangString ${STATEMENT_ID} ${LANG_ID} "${LOCALE}"
!macroend
!define TRANSLATE "!insertmacro TRANSLATE"


# ---------------
# Select Language Dialog
# ---------------
!macro SelectLanguageDialog
    Push ""
    !include "${__LOCALE_LIST}"
    !delfile "${__LOCALE_LIST}"
    Push A
    LangDLL::LangDialog "Installer Language" "Please select the language of the installer"
    Pop $LANGUAGE

    ${If} "$LANGUAGE" == "cancel"
		Abort
    ${EndIf}
!macroend



