################################################################################
# Feuerfuchs Addons Installer -- TargetApp Handler
#   file: Source\Lib\TargetApp.nsh
#   desc: To provide several function that deal with TargetApp(Firefox)
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# Macros
################################################################################

# ---------------
# Find TargetApp Executable (Macro)
# ---------------
!macro FindTargetAppEXE
    Push $0
    Push $1
    Call FindTargetAppEXE
    Pop $1
    Pop $0
!macroend
!define FindTargetAppEXE "!insertmacro FindTargetAppEXE"


# ---------------
# Find TargetApp Window (Macro)
# ---------------
!macro FindTargetAppProcess RETURNVAL
    Push $0
    Call FindTargetAppProcess
    Exch
    Pop $0
    Pop ${RETURNVAL}
!macroend
!define FindTargetAppProcess "!insertmacro FindTargetAppProcess"



################################################################################
# Functions
################################################################################

# ---------------
# Find TargetApp Executable
# ---------------
Function FindTargetAppEXE
    ; ----- Variables Defination -----
    !define FX_VER $0
    !define FX_PATH $1

    ; ----- Main -----
    ReadRegStr ${FX_VER} ${DETECT_INSTALL_APP_VERSION_KEY}

    ${If} ${Errors}
        ClearErrors
        SetErrors
        Return
    ${Else}
        ReadRegStr ${FX_PATH} ${DETECT_INSTALL_APP_PATH_KEY}

        ${If} ${Errors}
            ClearErrors
            SetErrors
            Return
        ${Else}
            ${If} ${FileExists} "${FX_PATH}"
                StrCpy $_TargetAppExecutable_ "${FX_PATH}"
            ${Else}
                SetErrors
                Return
            ${EndIf}
        ${EndIf}
    ${EndIf}

    ; ----- Variables Undefination -----
    !undef FX_VER
    !undef FX_PATH
FunctionEnd


# ---------------
# Find TargetApp Window
# ---------------
Function FindTargetAppProcess
    ; ----- Variables Define -----
    !define RESULT $0

    ; ----- Main -----

    ; Find Process
    ${FindProc} ${RESULT} "${APP_EXE_NAME}"

    ; Make Return
    ${If} ${RESULT} == "0"
        Push "false"
    ${Else}
        Push "true"
    ${EndIf}

    ; ----- Variables Undefine -----
    !undef RESULT
FunctionEnd




