################################################################################
# Feuerfuchs Addons Installer -- PagesClass: Close TargetApp Page
#   file: Source\PagesClass\CloseTargetAppPage.nsh
#   desc: `Close TargetApp Page' Init, Callback Functions.
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# Variables
################################################################################
;Var "_CloseTargetAppGroupBoxID_"
Var "_CloseTargetAppLabelID_"
;Var "_CloseTargetAppImageID_"


################################################################################
# Function
################################################################################

# ---------------
# Close TargetApp Page Init
# ---------------
Function CloseTargetAppPageInit
    ; ----- Variables Push -----
    Push $0
    !define FOUND_TARGETAPP $0

    ; ----- Main -----

    ; Find TargeApp Process
    ${FindTargetAppProcess} ${FOUND_TARGETAPP}
    ${If} "${FOUND_TARGETAPP}" == "false"
        Abort ; Skip this page
    ${EndIf}

    ; Handle the Locale
    !insertmacro MUI_INSTALLOPTIONS_WRITE "CloseTargetAppPage.ini" "Field 1" "Text" "$(CloseTargetAppHint)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "CloseTargetAppPage.ini" "Field 2" "Text" "$(CloseTargetAppHintContent)"

    ; Handle the Image
    File "/oname=$PLUGINSDIR\CloseTargetAppImage.bmp" "Source\Resources\Image\CloseTargetAppImage.bmp"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "CloseTargetAppPage.ini" "Field 3" "Text" "$PLUGINSDIR\CloseTargetAppImage.bmp"

    ; Initialize the Form
    !insertmacro MUI_HEADER_TEXT "$(CloseTargetAppHint)" "$(CloseTargetAppHintSub)"
    !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "CloseTargetAppPage.ini"
    Pop $_HWND_

    ; Get the Components' ID
;    !insertmacro MUI_INSTALLOPTIONS_READ $_CloseTargetAppGroupBoxID_ "CloseTargetAppPage.ini" "Field 1" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_CloseTargetAppLabelID_ "CloseTargetAppPage.ini" "Field 2" "HWND"
;    !insertmacro MUI_INSTALLOPTIONS_READ $_CloseTargetAppImageID_ "CloseTargetAppPage.ini" "Field 3" "HWND"

    ; Set Label to Bold
    ${GC::SetBold} $_CloseTargetAppLabelID_

    ; Show This Page Now
    !insertmacro MUI_INSTALLOPTIONS_SHOW

    ; ----- Variables Pop -----
    !undef FOUND_TARGETAPP
    Pop $0
FunctionEnd


# ---------------
# Close TargetApp Page Callback
# ---------------
Function CloseTargetAppPageCallback
    ; ----- Variables Push -----
    Push $0
    !define FOUND_TARGETAPP $0

    ; ----- Main -----

    ${FindTargetAppProcess} ${FOUND_TARGETAPP}
    ${If} ${FOUND_TARGETAPP} == "true"
        MessageBox MB_OK|MB_ICONSTOP "$(CloseTargetAppHintContent)"
        Abort ; Not Able to Go to Next
    ${EndIf}

    ; ----- Variables Pop -----
    !undef FOUND_TARGETAPP
    Pop $0
FunctionEnd





