################################################################################
# Feuerfuchs Addons Installer -- PagesClass: Components Page
#   file: Source\PagesClass\ComponentsPage.nsh
#   desc: Deal with `Components Page'
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# Macros
################################################################################

# ---------------
# On Selected Change Implements (Macro)
# ---------------
!macro OnSelChangeImpl
    Push $0
    Call OnSelChangeImpl
    Pop $0
!macroend
!define OnSelChangeImpl "!insertmacro OnSelChangeImpl"


# ---------------
# Check Depend Conflict (Macro)
# ---------------
!macro CheckDependConflict ADDON_TYPE ID
    Push "${ID}" ; STACK: ${ID}
    Push "${ADDON_TYPE}" ; STACK: ${ID}|${ADDON_TYPE}
    Exch $0 ; $0 = ${ADDON_TYPE}, STACK: ${ID}|$0
    Exch ; STACK: $0|${ID}
    Exch $1 ; $1 = ${ID}, STACK: $0|$1
    Push $2 ; STACK: $0|$1|$2
    Push $3 ; STACK: $0|$1|$2|$3
    Push $4 ; STACK: $0|$1|$2|$3|$4
    Push $5 ; STACK: $0|$1|$2|$3|$4|$5
    Push $6 ; STACK: $0|$1|$2|$3|$4|$5|$6
    Push $7 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7
    Push $8 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8
    Push $9 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8|$9
    Push $R1 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8|$9|$R1
    Push $R2 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8|$9|$R1|$R2
    Push $R3 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8|$9|$R1|$R2|$R3
    Call CheckDependConflict
    Pop $R3 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8|$9|$R1|$R2
    Pop $R2 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8|$9|$R1
    Pop $R1 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8|$9
    Pop $9 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7|$8
    Pop $8 ; STACK: $0|$1|$2|$3|$4|$5|$6|$7
    Pop $7 ; STACK: $0|$1|$2|$3|$4|$5|$6
    Pop $6 ; STACK: $0|$1|$2|$3|$4|$5
    Pop $5 ; STACK: $0|$1|$2|$3|$4
    Pop $4 ; STACK: $0|$1|$2|$3
    Pop $3 ; STACK: $0|$1|$2
    Pop $2 ; STACK: $0|$1
    Pop $1 ; STACK: $0
    Pop $0
!macroend
!define CheckDependConflict "!insertmacro CheckDependConflict"



################################################################################
# Function
################################################################################

# ---------------
# Components Page Init
# ---------------
Function ComponentsPageInit
    ; ----- Variables Push -----
    Push $0
    Push $1
    !define FOUND_TARGETAPP $0
    !define NEXT_BTN $1

    ; ----- Main -----
    ${FindTargetAppProcess} ${FOUND_TARGETAPP}
    ${If} "${FOUND_TARGETAPP}" == "false"
        GetDlgItem ${NEXT_BTN} $HWNDPARENT "1"
        SendMessage ${NEXT_BTN} ${WM_SETTEXT} 1 "STR:$(^InstallBtn)"
    ${EndIf}

    ; ----- Variables Pop -----
    !undef FOUND_TARGETAPP
    !undef NEXT_BTN
    Pop $1
    Pop $0
FunctionEnd


# ---------------
# On Section Selecting Change (Function Callback, implements in other function)
# ---------------
Function .onSelChange
    ${OnSelChangeImpl}
FunctionEnd


# ---------------
# On Select Change Implements
# ---------------
Function OnSelChangeImpl
    ; ----- Variables Define -----
    !define COUNT $0

    ${If} ${Errors}
        MessageBox MB_OK "Error: ${__FILE__}:${__LINE__}"
    ${EndIf}
    ; ----- Main -----
    ${For} ${COUNT} 1 ${EXTENSION_COUNTER}
        ${If} ${SectionIsModified} "Section_Extension${COUNT}"
            ${If} ${SectionIsSelectedAdv} "Section_Extension${COUNT}"
                ${CheckDependConflict} "Extension" "${COUNT}"
            ${EndIf}

            ${UPDATE_SECTION_STATE} "Section_Extension${COUNT}"
        ${EndIf}
    ${Next}

    ${For} ${COUNT} 1 ${THEME_COUNTER}
        ${If} ${SectionIsModified} "Section_Theme${COUNT}"
            ${If} ${SectionIsSelectedAdv} "Section_Theme${COUNT}"
                ${CheckDependConflict} "Theme" "${COUNT}"
            ${EndIf}

            ${UPDATE_SECTION_STATE} "Section_Theme${COUNT}"
        ${EndIf}
    ${Next}

    ${For} ${COUNT} 1 ${SEARCHPLUGIN_COUNTER}
        ${If} ${SectionIsModified} "Section_SearchPlugin${COUNT}"
            ${If} ${SectionIsSelectedAdv} "Section_SearchPlugin${COUNT}"
                ${CheckDependConflict} "SearchPlugin" "${COUNT}"
            ${EndIf}

            ${UPDATE_SECTION_STATE} "Section_SearchPlugin${COUNT}"
        ${EndIf}
    ${Next}

    ${If} ${Errors}
        MessageBox MB_OK "Error: ${__FILE__}:${__LINE__}"
    ${EndIf}
    ; ----- Variables Undefine -----
    !undef COUNT
FunctionEnd


# ---------------
# Check Depend Conflict
# ---------------
Function CheckDependConflict
    ; ----- Variables Define -----
    !define ADDON_TYPE $0
    !define ID $1
    !define DEPEND_LIST $2
    !define CONFLICT_LIST $3
    !define DEPEND_LIST_LEN $4
    !define DEPEND_LIST_MAXCHAR $4
    !define CONFLICT_LIST_LEN $5
    !define CONFLICT_LIST_MAXCHAR $5
    !define COUNT $6
    !define CHAR $7
    !define OBJECT $8
    !define OBJECT_NAME $9
    !define TEMP $R1
    !define TYPE $R2
    !define DISPLAY_SAFE_MODE_INFO $R3

    ; ----- Main -----
    ReadINIStr ${DEPEND_LIST} "${RELATION_TAB}" "Dependence" "${ADDON_TYPE}${ID}"
    ReadINIStr ${CONFLICT_LIST} "${RELATION_TAB}" "Conflict" "${ADDON_TYPE}${ID}"
    StrCpy ${DEPEND_LIST} "${DEPEND_LIST} " ; Add a SPACE so that we can make sure all item will be checked!
    StrCpy ${CONFLICT_LIST} "${CONFLICT_LIST} " ; Add a SPACE so that we can make sure all item will be checked!
    StrLen ${DEPEND_LIST_LEN} ${DEPEND_LIST}
    StrLen ${CONFLICT_LIST_LEN} ${CONFLICT_LIST}
    IntOp ${DEPEND_LIST_MAXCHAR} ${DEPEND_LIST_LEN} - 1
    IntOp ${CONFLICT_LIST_MAXCHAR} ${CONFLICT_LIST_LEN} - 1

    ; Dependence:
    ${For} ${COUNT} 0 ${DEPEND_LIST_MAXCHAR}
        StrCpy ${CHAR} ${DEPEND_LIST} 1 ${COUNT}

        ${Switch} ${CHAR}
            ${Case} ","
            ${Case} " "
            ${Case} "$\t"
                ; A Statement Finished, Execute It!
                ${If} ${OBJECT} != ""
                    ${Unless} ${SectionIsSelectedAdv} "Section_${OBJECT}"
                        ${GetSectionNameBySecIdxName} ${OBJECT_NAME} "Section_${OBJECT}"
                        ${MBYesNoValue} ${TEMP} "$(QSelectDepended)"

                        ${If} "${TEMP}" == "yes"
                            ${SelectSectionAdv} "Section_${OBJECT}"
                            ${UPDATE_SECTION_STATE} "Section_${OBJECT}"
                        ${Else}
                            StrCpy ${DISPLAY_SAFE_MODE_INFO} "true"
                        ${EndIf}
                    ${EndIf}
                ${EndIf}

                ${Break}

            ${Case} "E"
                ; Extension
                StrCpy ${OBJECT} "Extension"
                StrCpy ${TYPE} "$(Extension)"
                ${Break}

            ${Case} "T"
                ; Theme
                StrCpy ${OBJECT} "Theme"
                StrCpy ${TYPE} "$(Theme)"
                ${Break}

            ${Case} "S"
                ; Search Plugin
                StrCpy ${OBJECT} "SearchPlugin"
                StrCpy ${TYPE} "$(SearchPlugin)"
                ${Break}

            ${Case} "0"
            ${Case} "1"
            ${Case} "2"
            ${Case} "3"
            ${Case} "4"
            ${Case} "5"
            ${Case} "6"
            ${Case} "7"
            ${Case} "8"
            ${Case} "9"
                StrCpy ${Object} "${Object}${CHAR}"
                ${Break}
        ${EndSwitch}
    ${Next}

    ; Conflict:
    ${For} ${COUNT} 0 ${CONFLICT_LIST_MAXCHAR}
        StrCpy ${CHAR} ${CONFLICT_LIST} 1 ${COUNT}

        ${Switch} ${CHAR}
            ${Case} ","
            ${Case} " "
            ${Case} "$\t"
                ; A Statement Finished, Execute It!
                ${If} ${OBJECT} != ""
                    ${If} ${SectionIsSelectedAdv} "Section_${OBJECT}"
                        ${GetSectionNameBySecIdxName} ${OBJECT_NAME} "Section_${OBJECT}"
                        ${MBYesNoValue} ${TEMP} "$(QUnselectConflicted)"

                        ${If} "${TEMP}" == "yes"
                            ${UnselectSectionAdv} "Section_${OBJECT}"
                            ${UPDATE_SECTION_STATE} "Section_${OBJECT}"
                        ${Else}
                            StrCpy ${DISPLAY_SAFE_MODE_INFO} "true"
                        ${EndIf}
                    ${EndIf}

                    ; Empty the ${OBJECT}
                    StrCpy ${OBJECT} ""
                ${EndIf}

                ${Break}

            ${Case} "E"
                ; Extension
                StrCpy ${OBJECT} "Extension"
                StrCpy ${TYPE} "$(Extension)"
                ${Break}

            ${Case} "T"
                ; Theme
                StrCpy ${OBJECT} "Theme"
                StrCpy ${TYPE} "$(Theme)"
                ${Break}

            ${Case} "S"
                ; Search Plugin
                StrCpy ${OBJECT} "SearchPlugin"
                StrCpy ${TYPE} "$(SearchPlugin)"
                ${Break}

            ${Case} "0"
            ${Case} "1"
            ${Case} "2"
            ${Case} "3"
            ${Case} "4"
            ${Case} "5"
            ${Case} "6"
            ${Case} "7"
            ${Case} "8"
            ${Case} "9"
                StrCpy ${Object} "${OBJECT}${CHAR}"
                ${Break}
        ${EndSwitch}
    ${Next}

    ${If} "${DISPLAY_SAFE_MODE_INFO}" == "true"
        MessageBox MB_OK|MB_ICONINFORMATION "$(SafeModeInformation)"
    ${EndIf}

    ; ----- Variables Undefine -----
    !undef ADDON_TYPE
    !undef ID
    !undef DEPEND_LIST
    !undef CONFLICT_LIST
    !undef DEPEND_LIST_LEN
    !undef DEPEND_LIST_MAXCHAR
    !undef CONFLICT_LIST_LEN
    !undef CONFLICT_LIST_MAXCHAR
    !undef COUNT
    !undef CHAR
    !undef OBJECT
    !undef OBJECT_NAME
    !undef TEMP
    !undef TYPE
    !undef DISPLAY_SAFE_MODE_INFO
FunctionEnd



