################################################################################
# Feuerfuchs Addons Installer -- PagesClass: Profile Setting Page
#   file: Source\PagesClass\ProfileSettingPage.nsh
#   desc: `Profile Setting Page' Init, Callback, Redraw Functions.
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# Variables
################################################################################
; Variables that Store the Components' ID
;Var "_ProfileGroupBoxID_"
Var "_ProfileRBUseExistingID_"
Var "_ProfileRBBrowseID_"
Var "_ProfileRBNewID_"
Var "_ProfileListBoxID_"
Var "_ProfileDirBrowseTextID_"
Var "_ProfileDirBrowseBtnID_"
;Var "_ProfileNewNameLabelID_"
Var "_ProfileNewNameID_"



################################################################################
# Macro
################################################################################

# ---------------
# Profile Listing ListBox Draw/Redraw (Macro)
# ---------------
!macro ProfileLBRedraw
    Push $0
    Push $1
    Push $2
    Call ProfileLBRedraw
    Pop $2
    Pop $1
    Pop $0
!macroend
!define ProfileLBRedraw "!insertmacro ProfileLBRedraw"

# ----------------
# Profile Next Button Handling
# ----------------
!macro ProfileNextButtonHandle
    Push $0
    Push $1
    Push $2
    Push $3
    Call ProfileNextButtonHandle
    Pop $3
    Pop $2
    Pop $1
    Pop $0
!macroend
!define ProfileNextButtonHandle "!insertmacro ProfileNextButtonHandle"



################################################################################
# Functions
################################################################################

# ---------------
# Profile Page Init
# ---------------
Function ProfileSettingPageInit
    ; ----- Variables Push -----
    Push $0
    Push $1
    Push $2
    !define COUNT $0
    !define PROFILES_NUM $1
    !define PROFILE_NAME $2

    ; ----- Main -----

    ; Read the profiles.ini First
    ${ReadProfilesINI}

    ; Modify if profile.ini is not Aviable
    ${If} $_ExistProfilesCount_ = 0
        !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 2" "State" "0"
        !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 4" "State" "1"
    ${Else}
        !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 2" "State" "1"
        !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 4" "State" "0"
    ${EndIf}

    ; Handle the Locale
    !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 1" "Text" "$(ProfileSettingPage)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 2" "Text" "$(SelectExistingProfile)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 3" "Text" "$(BrowseProfile)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 4" "Text" "$(CreateProfile)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "ProfileSettingPage.ini" "Field 7" "Text" "$(ProfileName)"

    ; Initialize the Form
    !insertmacro MUI_HEADER_TEXT "$(ProfileSettingPage)" "$(ProfileSettingPageSub)"
    !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "ProfileSettingPage.ini"
    Pop $_HWND_

    ; Get the Components' ID
;    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileGroupBoxID_ "ProfileSettingPage.ini" "Field 1" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileRBUseExistingID_ "ProfileSettingPage.ini" "Field 2" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileRBBrowseID_ "ProfileSettingPage.ini" "Field 3" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileRBNewID_ "ProfileSettingPage.ini" "Field 4" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileListBoxID_ "ProfileSettingPage.ini" "Field 5" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileDirBrowseTextID_ "ProfileSettingPage.ini" "Field 6" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileDirBrowseBtnID_ "ProfileSettingPage.ini" "Field 6" "HWND2"
;    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileNewNameLabelID_ "ProfileSettingPage.ini" "Field 7" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_ProfileNewNameID_ "ProfileSettingPage.ini" "Field 8" "HWND"

    ; Change the Style of Radio Component
    ${GC::SetBold} $_ProfileRBUseExistingID_
    ${GC::SetBold} $_ProfileRBBrowseID_
    ${GC::SetBold} $_ProfileRBNewID_

    ; Deal with Profiles ListBox
    ${If} $_ExistProfilesCount_ = 0
        ; Disable the ListBox
        EnableWindow $_ProfileRBUseExistingID_ 0
        EnableWindow $_ProfileListBoxID_ 0
    ${Else}
        ; Add the Profile List To ListBox
        ${ProfileLBRedraw}
    ${EndIf}


    ; Show This Page Now
    !insertmacro MUI_INSTALLOPTIONS_SHOW

    ; ----- Variables Restore -----
    !undef COUNT
    !undef PROFILES_NUM
    !undef PROFILE_NAME
    Pop $2
    Pop $1
    Pop $0
FunctionEnd


# ---------------
# Profile Page Callback
# ---------------
Function ProfileSettingPageCallback
    ; Get the State
    !insertmacro MUI_INSTALLOPTIONS_READ $_State_ "ProfileSettingPage.ini" "Settings" "State"

    ${Switch} $_State_
        ${Case} 0
            ; Next Clicked!

            ; ----- Handle with the Option -----
            ${ProfileNextButtonHandle}
            ${If} ${Errors}
                ClearErrors
                Abort
            ${EndIf}

            ${Break}

        ${Case} 5
            ; ListBox Clicked!
            ${RB::Select} $_ProfileRBUseExistingID_
            ${RB::Unselect} $_ProfileRBBrowseID_
            ${RB::Unselect} $_ProfileRBNewID_
            Abort
            ${Break}

        ${Case} 6
            ; Browse Button Clicked!
            ${RB::Unselect} $_ProfileRBUseExistingID_
            ${RB::Select} $_ProfileRBBrowseID_
            ${RB::Unselect} $_ProfileRBNewID_
            Abort
            ${Break}

        ${CaseElse}
            Abort
            ${Break}
    ${EndSwitch}
FunctionEnd


# ---------------
# Profile Listing ListBox Draw/Redraw
# ---------------
Function ProfileLBRedraw
    ; ----- Define Variables Name -----
    !define PROFILES_NUM $0
    !define PROFILE_NAME $1
    !define COUNT $2

    ; ----- Main -----

    ; Clear the Existing Ones
    ${LB::Clear} $_ProfileListBoxID_

    ; Add the New Ones
    IntOp ${PROFILES_NUM} $_ExistProfilesCount_ - 1 ; Because Start from Zero
    ${For} ${COUNT} 0 ${PROFILES_NUM}
        ReadINIStr ${PROFILE_NAME} "$PLUGINSDIR\ProfileTab.ini" "NameTab" "Name${COUNT}"
        ${LB::AddString} $_ProfileListBoxID_ "${PROFILE_NAME}"
    ${Next}

    ; Select Default One
    ${LB::SelectItem} $_ProfileListBoxID_ $_DefaultProfileId_

    ; ----- Undefine Variables Name -----
    !undef PROFILES_NUM
    !undef PROFILE_NAME
    !undef COUNT
FunctionEnd


# ----------------
# Profile Next Button Handling
# ----------------
Function ProfileNextButtonHandle
    ; ----- Variables Define -----
    !define RB_OPTIONS_USE_EXIST $0
    !define RB_OPTIONS_BROWSE $1
    !define RB_OPTIONS_CREATE_NEW $2
    !define TEMP $3

    ; ----- Main -----
    !insertmacro MUI_INSTALLOPTIONS_READ ${RB_OPTIONS_USE_EXIST} "ProfileSettingPage.ini" "Field 2" "State"
    !insertmacro MUI_INSTALLOPTIONS_READ ${RB_OPTIONS_BROWSE} "ProfileSettingPage.ini" "Field 3" "State"
    !insertmacro MUI_INSTALLOPTIONS_READ ${RB_OPTIONS_CREATE_NEW} "ProfileSettingPage.ini" "Field 4" "State"

    ${If} ${RB_OPTIONS_USE_EXIST} == "1"
        ; Using Existing Profile
        ${LB::GetSelectItem} $_ProfileListBoxID_ ${TEMP}
        ReadINIStr $_TargetProfileDir_ "$PLUGINSDIR\ProfileTab.ini" "PathTab" "Path${TEMP}"
        StrCpy $_ProfileType_ "Exist"
    ${ElseIf} ${RB_OPTIONS_BROWSE} == "1"
        !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP} "ProfileSettingPage.ini" "Field 6" "State"

        ${If} ${FileExists} ${TEMP}
            StrCpy $_TargetProfileDir_ "${TEMP}"
            StrCpy $_ProfileType_ "Browse"
        ${Else}
            MessageBox MB_OK|MB_ICONEXCLAMATION "$(PleaseEnterCorrectPath)"
            SetErrors
            Return
        ${EndIf}
    ${ElseIf} ${RB_OPTIONS_CREATE_NEW} == "1"
        !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP} "ProfileSettingPage.ini" "Field 8" "State"

        ${If} "${TEMP}" == ""
            MessageBox MB_OK|MB_ICONEXCLAMATION "$(ProfileNameCantBeEmpty)"
            SetErrors
            Return
        ${EndIf}

        ${CreateNewProfile} "${TEMP}"
        ${If} ${Errors}
            ClearErrors
            SetErrors
            Return
        ${Else}
            MessageBox MB_OK|MB_ICONINFORMATION "$(NewProfileCreated)"
        ${EndIf}

        StrCpy $_ProfileType_ "New"
    ${EndIf}

    ; ----- Variables Undefine -----
    !undef RB_OPTIONS_USE_EXIST
    !undef RB_OPTIONS_BROWSE
    !undef RB_OPTIONS_CREATE_NEW
    !undef TEMP
FunctionEnd




