################################################################################
# Feuerfuchs Addons Installer -- PagesClass:TargetAppSettingPage
#   file: Source\PagesClass\TargetAppSettingPage.nsh
#   desc: `TargetApp Setting Page' Init, Callback
#   author: hobbyscripter<hobbyscripter@gmail.com>
#   version: 2.0.1.0
#   copyright: abandoned!
################################################################################



################################################################################
# Variables
################################################################################
;Var "_TargetAppGroupBoxID_"
;Var "_TargetAppWelcomeLabelID_"
Var "_TargetAppRBBrowseID_"
Var "_TargetAppRBIgnoreID_"
Var "_TargetAppRBInstallID_"
;Var "_TargetAppBrowseLabelID_"
Var "_TargetAppBrowseTextID_"
Var "_TargetAppBrowseBtnID_"



################################################################################
# Macros
################################################################################

# ---------------
# TargetApp Next Button Handle
# ---------------
!macro TargetAppNextButtonHandle
    Push $0
    Push $1
    Push $2
    Push $3
    Call TargetAppNextButtonHandle
    Pop $3
    Pop $2
    Pop $1
    Pop $0
!macroend
!define TargetAppNextButtonHandle "!insertmacro TargetAppNextButtonHandle"



################################################################################
# Functions
################################################################################

# ---------------
# TargetApp Page Init
# ----------------
Function TargetAppSettingPageInit
    ; Modify If Find or Unfind TargetApp Executable
    ${FindTargetAppEXE}
    ${If} ${Errors}
        !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 3" "State" "0"
        !if "${PROVIDE_APP_INSTALLER}" == "true"
            !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 5" "State" "1"
        !else
            !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 4" "State" "1"
        !endif

        ClearErrors
    ${Else}
        !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 7" "State" "$_TargetAppExecutable_"
    ${EndIf}

    ; Handle the Locale
    !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 1" "Text" "$(TargetAppSettingPage)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 2" "Text" "$(TargetAppSettingDesc)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 3" "Text" "$(BrowseTargetApp)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 4" "Text" "$(IgnoreTargetApp)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 5" "Text" "$(InstallTargetApp)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 6" "Text" "$(BrowseTargetAppField)"
    !insertmacro MUI_INSTALLOPTIONS_WRITE "TargetAppSettingPage.ini" "Field 7" "Filter" "$(ExecutableFilter)"

    ; Initialize the Form
    !insertmacro MUI_HEADER_TEXT "$(TargetAppSettingPage)" "$(TargetAppSettingPageSub)"
    !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "TargetAppSettingPage.ini"
    Pop $_HWND_

    ; Get the Components' ID
;    !insertmacro MUI_INSTALLOPTIONS_READ $_TargetAppGroupBoxID_ "TargetAppSettingPage.ini" "Field 1" "HWND"
;    !insertmacro MUI_INSTALLOPTIONS_READ $_TargetAppWelcomeLabelID_ "TargetAppSettingPage.ini" "Field 2" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_TargetAppRBBrowseID_ "TargetAppSettingPage.ini" "Field 3" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_TargetAppRBIgnoreID_ "TargetAppSettingPage.ini" "Field 4" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_TargetAppRBInstallID_ "TargetAppSettingPage.ini" "Field 5" "HWND"
;    !insertmacro MUI_INSTALLOPTIONS_READ $_TargetAppBrowseLabelID_ "TargetAppSettingPage.ini" "Field 6" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_TargetAppBrowseTextID_ "TargetAppSettingPage.ini" "Field 7" "HWND"
    !insertmacro MUI_INSTALLOPTIONS_READ $_TargetAppBrowseBtnID_ "TargetAppSettingPage.ini" "Field 7" "HWND2"

    ; Set RadioBox to Bold
    ${GC::SetBold} $_TargetAppRBBrowseID_
    ${GC::SetBold} $_TargetAppRBIgnoreID_
    ${GC::SetBold} $_TargetAppRBInstallID_

    ; Disable `Install TargetApp' if Not Providing
    !if "${PROVIDE_APP_INSTALLER}" != "true"
        EnableWindow $_TargetAppRBInstallID_ 0
    !endif

    ; Show This Page Now
    !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd


# ---------------
# TargetApp Page Callback
# ---------------
Function TargetAppSettingPageCallback
    ; Get the State
    !insertmacro MUI_INSTALLOPTIONS_READ $_State_ "TargetAppSettingPage.ini" "Settings" "State"

    ${Switch} $_State_
        ${Case} 0
            ; Next Clicked!

            ; Call the Handler
            ${TargetAppNextButtonHandle}

            ; Abort If Errors
            ${If} ${Errors}
                ClearErrors
                Abort
            ${EndIf}

            ${Break}

        ${Case} 7
            ; Browse File Button Clicked!
            ${RB::Select} $_TargetAppRBBrowseID_
            ${RB::Unselect} $_TargetAppRBIgnoreID_
            ${RB::Unselect} $_TargetAppRBInstallID_
            Abort
            ${Break}

        ${CaseElse}
            ; Other Event
            Abort
            ${Break}
    ${EndSwitch}
FunctionEnd


# ---------------
# TargetApp Next Button Handle
# ---------------
Function TargetAppNextButtonHandle
    ; ----- Variables Defination -----
    !define RB_OPTIONS_BROWSE $0
    !define RB_OPTIONS_IGNORE $1
    !define RB_OPTIONS_INSTALL $2
    !define TEMP $3

    ; ----- Main -----

    ; Read the State
    !insertmacro MUI_INSTALLOPTIONS_READ ${RB_OPTIONS_BROWSE} "TargetAppSettingPage.ini" "Field 3" "State"
    !insertmacro MUI_INSTALLOPTIONS_READ ${RB_OPTIONS_IGNORE} "TargetAppSettingPage.ini" "Field 4" "State"
    !insertmacro MUI_INSTALLOPTIONS_READ ${RB_OPTIONS_INSTALL} "TargetAppSettingPage.ini" "Field 5" "State"

    ; Handle Options
    ${If} ${RB_OPTIONS_BROWSE} == "1"
        ; Selected `Browse' Option
        StrCpy $_AppEXEType_ "Browse"

        ; Read the Path
        !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP} "TargetAppSettingPage.ini" "Field 7" "State"

        ${Unless} ${FileExists} "${TEMP}"
            MessageBox MB_OK|MB_ICONEXCLAMATION "$(TargetAppEXENotExist)"
            SetErrors
            Return
        ${Else}
            StrCpy $_TargetAppExecutable_ "${TEMP}"
        ${EndUnless}

        ; Help User Unelect `Install TargetApp' by Default
        !if "${PROVIDE_APP_INSTALLER}" == "true"
        ${UnselectSectionAdv} "Section_InstallApp"
        !endif
    ${ElseIf} ${RB_OPTIONS_IGNORE} == "1"
        ; Selected `Ignore' Option
        StrCpy $_AppEXEType_ "Ignore"
        StrCpy $_TargetAppExecutable_ ""

        ; Help User Unelect `Install TargetApp' by Default
        !if "${PROVIDE_APP_INSTALLER}" == "true"
        ${UnselectSectionAdv} "Section_InstallApp"
        !endif
    ${ElseIf} ${RB_OPTIONS_INSTALL} == "1"
        ; Selected `Install' Option
        StrCpy $_AppEXEType_ "Install"
        StrCpy $_TargetAppExecutable_ ""

        ; Help User Select `Install TargetApp' by Default
        !if "${PROVIDE_APP_INSTALLER}" == "true"
        ${SelectSectionAdv} "Section_InstallApp"
        !endif
    ${EndIf}

    ; ----- Variables Undefination -----
    !undef RB_OPTIONS_BROWSE
    !undef RB_OPTIONS_IGNORE
    !undef RB_OPTIONS_INSTALL
    !undef TEMP
FunctionEnd
